//Interferències by Rosa
//parteixo de l'arxiu solució de la PAC3

int radius; // Radi de les partícules dibuixades
float pos_x; // Posició x de les partícules
float pos_x0; // Posició x de la partícula de més a l'esquerra
float pos_y1; // Posició y1 de les partícules
float pos_y2; // Posició y2 de les partícules
float pos_y3; // Posició y3 de les partícules
float pos_y0; // Posició y "central" (desfasament 0)
float Amp_y; // Amplitud de l'ona
float periode; // Període
float freq; // Freqüència
float lambda; // Longitud d'ona
float desfasament; // Desfasament
float time; // Temps


// Donem el valor inicial a les variables anteriors
void setup() {
size(600, 600); // Fixem la grandària de la finestra gràfica, 3 cops més gran que a la pac3
frameRate (70); // Fixem la freqüència de refresc
radius = 8; // Radi de les partícules dibuixades
pos_x = 30.0; // Posició x de les partícules
pos_x0 = 30.0; // Posició x de la partícula de més a l'esquerra
pos_y0 = 200.0; // Posició y "central" (desfasament 0)
Amp_y = 50.0; // Amplitud de l'ona
periode = 2.0; // Període
freq = 1/periode; // Freqüència
lambda = 300.0; // Longitud d'ona
desfasament = 0.0; // Desfasament
time = 0.0; // Temps
}

//Iniciem el bucle draw
void draw() {
background(255, 255, 255);
fill(102, 45, 145);
for (pos_x = 5; pos_x < 600; pos_x = pos_x + 10) {
  desfasament = 2*PI*pos_x/lambda;
  pos_y1 = height/4 + Amp_y*cos(2*PI*freq*time - desfasament) + Amp_y*cos(2*PI*freq*time - desfasament) ;
  pos_y2 = height/2 + Amp_y*cos(2*PI*freq*time - desfasament) + + Amp_y*cos(2*PI*freq*time - desfasament + 3.10) ; 
  pos_y3 = 3*height/4 + Amp_y*cos(2*PI*2*freq*time - desfasament) + Amp_y*cos(2*PI*freq/4*time - desfasament) ;  
  ellipse (pos_x, pos_y1, radius, radius);
  ellipse (pos_x, pos_y2, radius, radius);
  ellipse (pos_x, pos_y3, radius, radius);
 }
  time = time + 0.01;
}
