//Oscil·ladors en ressonància by Rosa
//partim de l'exercici de la PAC3

int radius; // Radi de les partícules dibuixades
float pos_x; // Posició x de les partícules
float pos_x0; // Posició x de la partícula de més a l'esquerra
float pos_y; // Posició y1 de les partícules
float pos_y0; // Posició y "central" (desfasament 0)
float Amp_y; // Amplitud de l'ona
float periode; // Període
float freq; // Freqüència
float lambda; // Longitud d'ona
float desfasament; // Desfasament
float time; // Temps


// Donem el valor inicial a les variables anteriors
void setup() {
size(600, 400); // Fixem la grandària de la finestra gràfica, 3 cops més gran que a la pac3
frameRate (100); // Fixem la freqüència de refresc a 100 perquè es correspongui amb el time a temps real
radius = 8; // Radi de les partícules dibuixades
pos_x = 30.0; // Posició x de les partícules
pos_x0 = 30.0; // Posició x de la partícula de més a l'esquerra
pos_y = 200.0; // Posició y de les partícules
pos_y0 = 200.0; // Posició y "central" (desfasament 0)
Amp_y = 50.0; // Amplitud de l'ona
periode = 2.0; // Període
freq = 1/periode; // Freqüència
lambda = 300.0; // Longitud d'ona
time = 0.01; // Temps
}

//Iniciem el bucle draw
void draw() {
background(255, 255, 255);
fill(102, 45, 145);

for (pos_x = 20; pos_x < 580; pos_x = pos_x + 40) {
  
  float i= (pos_x-20)/560*14+51; //definim els 15 punts entre 0 i 580, i el nombre d'oscil·lacions de cadascun a partir de 51, 52, 53... fins 65 
  pos_y = pos_y0 + Amp_y*cos(2*PI/(60/i)*time); //adaptem l'expressió a la que ens dóna l'enunciat substituïnt la freqüència pel període donat
  ellipse (pos_x, pos_y, radius, radius);

 }
  time = time + 0.01; //temps real
  text (time, 50, 50); //escrivim el temps en la finestra per poder fer les captures a 15, 30, 45 i 60 segons
}
